#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include "mylib.h"

// BrainF*ck SCript
char MyScript[64*1024] = { 'B', 'F', 'S', 'C' };

// MyScript:
// 0-3   BFSC
// 4-7   Script size
// 8-... Script 


int BFInterpret(char *Script, size_t ScriptSize);
int Binder(int argc, char *argv[]);

int
main(int argc, char *argv[])
{
  size_t *SizePtr = (size_t*)&MyScript[4];

  if(*SizePtr == 0)
  {
    return Binder(argc, argv);
  }
  else
  {
    return BFInterpret(MyScript + 8, *SizePtr);
  }

  return 0;
}

int
BFInterpret(char *Script, size_t ScriptSize)
{
  static unsigned char Memory[30000];
  int Ptr = 0;
  int IP  = 0; // Instruction Pointer

  for(;;)
  {
    // End of script?
    if(IP >= (int)ScriptSize)
      break;

    switch(Script[IP])
    {
      case '>': 
        Ptr++; 
        if(Ptr == 30000) Ptr = 0;
        IP++;
        break;

       case '<':
        Ptr--;
        if(Ptr == -1) Ptr = 29999;
        IP++;
        break;

       case '+':
        Memory[Ptr]++;
        IP++;
        break;

       case '-':
        Memory[Ptr]--;
        IP++;
        break;

       case '.':
        putchar((int)Memory[Ptr]);
        IP++;
        break;

       case ',':
        Memory[Ptr] = (unsigned char)getchar();
        IP++;
        break;

       case '[':
        if(Memory[Ptr] != 0)
        {
          IP++;
        }
        else
        {
          int Depth = 0;
          int i = IP + 1;
          while(i < (int)ScriptSize)
          {
            if(Script[i] == '[') Depth++;
            else if(Script[i] == ']') Depth--;

            i++;

            if(Depth == -1)
              break;
          }

          if(Depth != -1)
          {
            printf("error: missing pair ] at %i\n", IP);
            return 1;
          }

          IP = i;
        }
        break;

       case ']':
       {
         int Depth = 0;
         int i = IP - 1;
         while(i > 0)
         {
           if(Script[i] == '[') Depth++;
           else if(Script[i] == ']') Depth--;

           i--;

           if(Depth == 1)
             break;
         }

         if(Depth != 1)
         {
           printf("error: missing pair [ at %i\n", IP);
           return 2;
         }
         IP = i;
        }
       break;

       default:
       IP++;
    }
    
  }
   

  // All OK
  return 0;
}

int
Binder(int argc, char *argv[])
{
  const char *OutName = "a.exe";
  char SelfName[1024];
  char *SelfData = NULL;
  char *ScriptData = NULL;
  size_t SelfSize, i, ScriptSize;
  char *WriteData = NULL;
  
  if(argc < 2)
  {
    puts("usage: bfb <ScriptName> [ExeName]");
    return 1;
  }

  if(argc == 3)
  {
    OutName = argv[2];
  }

  printf("Binding script %s to %s\n", 
      argv[1],
      OutName);


  GetModuleFileName(
      GetModuleHandle(NULL),
      SelfName,
      sizeof(SelfName)
      );

  SelfData = readfile(SelfName, &SelfSize);
  if(!SelfData)
  {
    puts("error: could not read self");
    return 2;
  }

  for(i = 0; i + (64*1024 - 1) < SelfSize; i++)
  {
    if(SelfData[i] == 'B' &&
       SelfData[i+1] == 'F' &&
       SelfData[i+2] == 'S' &&
       SelfData[i+3] == 'C')
    {
      WriteData = SelfData + i;
      break;
    }
  } 

  if(WriteData == NULL)
  {
    puts("error: don't know what happend, magic missing");
    return 3;
  }

  ScriptData = readfile(argv[1], &ScriptSize);
  if(!ScriptData)
  {
    puts("error: could not open script file");
    return 4;
  }

  if(ScriptSize >= 64 * 1024 - 8)
  {
    puts("error: script to big, up to 64KB-8 supported");
    return 5;
  }

  // Copy script
  memcpy(WriteData + 8, ScriptData, ScriptSize);

  // Set size
  *(size_t*)(WriteData + 4) = ScriptSize;

  // Emit file
  writefile(OutName, SelfData, SelfSize);

  // Done
  puts("done.");
  return 0;
}

